<?php
// IMDb link transform
// version 0.3, 30-04-2008
//
// Copyleft (c) 2005-08 Psykotik
// http://www.ikiru.ch/blog
//
// **********************************************************************
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
// *****************************************************************

/*
Plugin Name: IMDb : <acronym title="internet movie database">IMDb</acronym> link transformer
Plugin URI: http://www.ikiru.ch/blog/category/computering/wordpress/
Description: Transforms every tag inside &lt; imdb &gt; (...) &lt;/ imdb &gt; to his equivalent linking to <a href="http://www.imdb.com"><acronym title="internet movie database">imdb</acronym></a>. Perfect for your movies reviews. Cache handling. Classes come from <a href="http://www.izzysoft.de/">imdbphp project</a>. 
Version: 0.3
Author: Psykotik
Author URI: http://www.ikiru.ch/blog
*/ 

// ---------------------
// --------------------- Fonctions
// --------------------- 

require_once ("config.php");

/*
1.- Remplacement des tags <imdb> dans les messages
*/

##### a) Recherche de tout ce qui est entre les tags <imdb> ... </imdb> et renvoit un lien pointant sur "popup.php"
function parse_imdb_tags($correspondances){
	global $plugin_directory, $linktitlephrase, $popupLarg, $popupLong;
    
	$correspondances = $correspondances[0];
	preg_match("/\<imdb\>(.*)\<\/imdb\>/i", $correspondances, $test);

	// construction du lien
	$test = "<a class=\"link-imdb\" href=\"#titre\" onclick=\"window.open('".$plugin_directory."popup.php?film="
    .imdb_htmlize($test[1])."', 'popup', 'resizable=yes, toolbar=no, scrollbars=yes, location=no, width=".$popupLarg
    .", height=".$popupLong.", top=5, left=5')\" title=\"".$linktitlephrase."\">".$test[1]."</a>";

	return $test;
}


##### b) Remplacement des tages <imdb> par les liens pointant sur "popup.php"
function imdb_linking($text) {
	$pattern = '/\<imdb\>(.*?)\<\/imdb\>/i';
	$text = preg_replace_callback($pattern,'parse_imdb_tags',$text);
	return $text;
}

/*
2.- Ajoute le tag <imdb> et </imdb> dans la page de rdaction d'un message (admin)
Bas sur Simon Elvery's Footnotes 0.2 (Beta)
http://www.elvery.net/drzax/
*/

function imdb_add_quicktag() {  
	if(strpos($_SERVER['REQUEST_URI'], 'post.php') || strpos($_SERVER['REQUEST_URI'], 'page-new.php')) {
		?>
		<script language="JavaScript" type="text/javascript"><!--
		var toolbar = document.getElementById("ed_toolbar");
		var buttonNumber = 0;
		if(toolbar)
		{
			document.getElementById("ed_toolbar").innerHTML += "<input type=\"button\" class=\"imdb_handler\" id=\"imdb_handler\" value=\"imdb\" onclick=\"edInsertTag(edCanvas, 6666); \" />";
			
			edButtons[6666] = 
			new edButton('imdb_handler'
				,'imdb'
				,'<imdb>'
				,'</imdb>'
				,''
			);
			
		}
		//--></script>
		<?php
	}
}

// ---------------------
// --------------------- filters
// ---------------------

/*
1.- transforme le nom des films pour tre recherchables (les  deviennent &ocirc; and so on ) 
*/ 

function imdb_htmlize ($lien) {
    // a. chappe les quotes posant problme
    $lienhtmlize = addslashes($lien);      
    // b.converti la db en html
    $lienhtmlize = htmlentities($lienhtmlize,ENT_NOQUOTES,"UTF-8");
    // c. expression rgulire pour remplacer tous les accents; fonctionnement bizarre..
    $lienhtmlize = preg_replace('/&(?!#[0-9]+;)/s', '&amp;', $lienhtmlize);
    // d. transforme les espaces en +, ce qui permet des titres en plusieurs mots spars d'tre recherchs
	$lienhtmlize = str_replace(array(' '), array('+'), $lienhtmlize);
    
    return $lienhtmlize; 
}

/*
2.- Add the stylesheet to the head of the page     
*/ 

function imdb_add_css () {
	global $plugin_directory;

	echo "
	<!-- Added by \"ImDB connect\" plugin -->
	<link rel=\"stylesheet\" href=\"".$plugin_directory."imdb.css\" type=\"text/css\" />
    <!-- /Added by \"ImDB connect\" plugin -->\n";
}

// ---------------------
// --------------------- Automatismes et excutions
// ---------------------



// Be sure WP is running
if (function_exists('add_action')) {
    // javascript for main blog
	add_action('wp_head', 'imdb_add_css');
	add_filter('the_content', 'imdb_linking', 2);
	add_filter('the_excerpt', 'imdb_linking', 2);
	add_action('admin_footer', 'imdb_add_quicktag');    
    // delete this one if you don't want it run on comments
	add_filter('comment_text', 'imdb_linking', 10);
}


?>
